// ******************* BASIC.VERT 

#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

uniform vec3 offset;
uniform vec3 myColor;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 lightSpaceMatrix;

out vec2 TexCoords;
out vec3 Normal;
out vec3 FragPos;
out vec4 FragPosLightSpace;

void main()
{
	gl_Position = projection * view * model * vec4(position, 1.0f);
	
	//Calculations in worldspace (use (view*model) for view-space)
	vec4 temp = vec4(model * vec4(position, 1.0f));
	// necessary to cast from vec4 to vec3!
	FragPos = vec3(temp.x, temp.y, temp.z);
	
	Normal = mat3(transpose(inverse(model))) * normal;
	// TODO Calculate in main, because more efficient!!!
	
	TexCoords = texCoords;
	// old: TexCoord = vec2(texCoord.x, 1.0f - texCoord.y);
	
	FragPosLightSpace = lightSpaceMatrix * vec4(FragPos, 1.0);
}

//ourColor = color;