// written using the tutorial on learnopengl.com
#version 330

in vec2 TexCoords;

out vec4 FragColor;

uniform sampler2D scene;
uniform sampler2D bloomBlur;

void main()
{
	vec3 baseColor = texture(scene, TexCoords).rgb;
	vec3 bloomColor = texture(bloomBlur, TexCoords).rgb;
	vec3 result = baseColor + 2 * bloomColor;
	if(result.r > 1.0f)
		result.r = 1.0f;
	if(result.g > 1.0f)
		result.g = 1.0f;
	if(result.b > 1.0f)
		result.b = 1.0f;

	FragColor = vec4(result, 1.0f);
}