#version 330

uniform vec3 lightPos;
uniform vec4 myColor;

in vec3 Normal;
in vec3 FragPos;

void main()
{
	float intensity;
	vec4 color;
	vec3 lightDir = normalize(lightPos - FragPos);
	intensity = dot(lightDir, normalize(normal));

	if (intensity > 0.95)
		color = Vec4(myColor.x * 1.0f, myColor.y * 1.0f, myColor.z * 1.0f, 1.0f);
	else if (intensity > 0.50)
		color = Vec4(myColor.x * 0.6f, myColor.y * 0.6f, myColor.z * 0.6f, 1.0f);
	else if (intensity > 0.25)
		color = Vec4(myColor.x * 0.4f, myColor.y * 0.4f, myColor.z * 0.4f, 1.0f);
	else
		color = Vec4(myColor.x * 0.2f, myColor.y * 0.2f, myColor.z * 0.2f, 1.0f);
	gl_FragColor = color;
	
}