#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

out vec3 Normal;

out vec3 FragPos;

void main()
{
	gl_Position = projection * view * model * vec4(position, 1.0f);
	
	//Calculations in worldspace (use (view*model) for view-space)
	vec4 temp = vec4(model * vec4(position, 1.0f));
	// necessary to cast from vec4 to vec3!

	FragPos = vec3(temp.x-10, temp.y-10, temp.z-10);

	Normal = mat3(transpose(inverse(model))) * normal;
}